Attribute VB_Name = "modCDecl"
Option Explicit

Private Declare Function LoadLibrary Lib "kernel32" _
                         Alias "LoadLibraryW" ( _
                         ByVal lpLibFileName As Long) As Long
Private Declare Function GetProcAddress Lib "kernel32" ( _
                         ByVal hModule As Long, _
                         ByVal lpProcName As String) As Long

Sub Main()
    Dim hMSVCrt         As Long
    Dim pfn_snwprintf   As Long
    Dim pfn_ultow       As Long
    Dim pfn_wcsupr      As Long
    Dim pfn_wstrtime_s  As Long
    Dim sBuffer         As String
    
    hMSVCrt = LoadLibrary(StrPtr("msvcrt"))
    
    pfn_snwprintf = GetProcAddress(hMSVCrt, "_snwprintf")
    pfn_ultow = GetProcAddress(hMSVCrt, "_ultow")
    pfn_wcsupr = GetProcAddress(hMSVCrt, "_wcsupr")
    pfn_wstrtime_s = GetProcAddress(hMSVCrt, "_wstrtime_s")
    
    sBuffer = String$(255, vbNullChar)
    
    CallCdecl4 pfn_snwprintf, StrPtr(sBuffer), Len(sBuffer), StrPtr("Test %ld"), 1234
    
    Debug.Print sBuffer
    
    CallCdecl3 pfn_ultow, &H80212123, StrPtr(sBuffer), 10
    
    Debug.Print sBuffer
    
    CallCdecl2 pfn_wstrtime_s, StrPtr(sBuffer), Len(sBuffer)
    
    Debug.Print sBuffer
    
    sBuffer = "HeLlO WoRlD!!!"
    
    CallCdecl1 pfn_wcsupr, StrPtr(sBuffer)
    
    Debug.Print sBuffer
    
End Sub
